'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _ = require('../');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

test('finds an external source map', _asyncToGenerator(_regenerator2.default.mark(function _callee() {
  var file, sm;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          file = _fs2.default.readFileSync((0, _path.resolve)(__dirname, '../../fixtures/bundle.js')).toString('utf8');

          fetch.mockResponseOnce(_fs2.default.readFileSync((0, _path.resolve)(__dirname, '../../fixtures/bundle.js.map')).toString('utf8'));

          _context.next = 4;
          return (0, _.getSourceMap)('/', file);

        case 4:
          sm = _context.sent;

          expect(sm.getOriginalPosition(26122, 21)).toEqual({
            line: 7,
            column: 0,
            source: 'webpack:///packages/react-scripts/template/src/App.js'
          });

        case 6:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
})));

test('find an inline source map', _asyncToGenerator(_regenerator2.default.mark(function _callee2() {
  var sourceName, file, fileO, sm;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          sourceName = 'test.js';
          file = _fs2.default.readFileSync((0, _path.resolve)(__dirname, '../../fixtures/inline.js')).toString('utf8');
          fileO = _fs2.default.readFileSync((0, _path.resolve)(__dirname, '../../fixtures/inline.es6.js')).toString('utf8');
          _context2.next = 5;
          return (0, _.getSourceMap)('/', file);

        case 5:
          sm = _context2.sent;

          expect(sm.getSources()).toEqual([sourceName]);
          expect(sm.getSource(sourceName)).toBe(fileO);
          expect(sm.getGeneratedPosition(sourceName, 5, 10)).toEqual({
            line: 10,
            column: 8
          });

        case 9:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, undefined);
})));

test('error on a source map with unsupported encoding', _asyncToGenerator(_regenerator2.default.mark(function _callee3() {
  var file;
  return _regenerator2.default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          expect.assertions(2);

          file = _fs2.default.readFileSync((0, _path.resolve)(__dirname, '../../fixtures/junk-inline.js')).toString('utf8');
          _context3.prev = 2;
          _context3.next = 5;
          return (0, _.getSourceMap)('/', file);

        case 5:
          _context3.next = 11;
          break;

        case 7:
          _context3.prev = 7;
          _context3.t0 = _context3['catch'](2);

          expect(_context3.t0 instanceof Error).toBe(true);
          expect(_context3.t0.message).toBe('Sorry, non-base64 inline source-map encoding is not supported.');

        case 11:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, undefined, [[2, 7]]);
})));